part of forestvpn_auth_api.api;

class IntrospectionRequest {
  /* The string value of the token.  For access tokens, this is the \"access_token\" value returned from the token endpoint defined in OAuth 2.0 */
  String token = null;
  /* A hint about the type of the token submitted for introspection.  The protected resource MAY pass this parameter to help the authorization server optimize the token lookup. */
  String tokenTypeHint = null;
  IntrospectionRequest();

  @override
  String toString() {
    return 'IntrospectionRequest[token=$token, tokenTypeHint=$tokenTypeHint, ]';
  }

  IntrospectionRequest.fromJson(Map<String, dynamic> json) {
    if (json == null) return;
    token = json['token'];
    tokenTypeHint = json['token_type_hint'];
  }

  Map<String, dynamic> toJson() {
    Map <String, dynamic> json = {};
    if (token != null)
      json['token'] = token;
    if (tokenTypeHint != null)
      json['token_type_hint'] = tokenTypeHint;
    return json;
  }

  static List<IntrospectionRequest> listFromJson(List<dynamic> json) {
    return json == null ? List<IntrospectionRequest>() : json.map((value) => IntrospectionRequest.fromJson(value)).toList();
  }

  static Map<String, IntrospectionRequest> mapFromJson(Map<String, dynamic> json) {
    var map = Map<String, IntrospectionRequest>();
    if (json != null && json.isNotEmpty) {
      json.forEach((String key, dynamic value) => map[key] = IntrospectionRequest.fromJson(value));
    }
    return map;
  }

  // maps a json object with a list of IntrospectionRequest-objects as value to a dart map
  static Map<String, List<IntrospectionRequest>> mapListFromJson(Map<String, dynamic> json) {
    var map = Map<String, List<IntrospectionRequest>>();
     if (json != null && json.isNotEmpty) {
       json.forEach((String key, dynamic value) {
         map[key] = IntrospectionRequest.listFromJson(value);
       });
     }
     return map;
  }
}

