part of forestvpn_auth_api.api;

class IntrospectionResponse {
  /* Boolean indicator of whether or not the presented token is currently active. */
  bool active = null;
  /* Service-specific string identifier or list of string identifiers representing the intended audience for this token, as defined in JWT */
  List<String> aud = [];
  /* Client identifier for the OAuth 2.0 client that requested this token. */
  String clientId = null;
  /* Integer timestamp, measured in the number of seconds since January 1 1970 UTC, indicating when this token will expire, as defined in JWT */
  int exp = null;
  /* Integer timestamp, measured in the number of seconds since January 1 1970 UTC, indicating when this token was originally issued, as defined in JWT */
  int iat = null;
  /* String representing the issuer of this token, as defined in JWT */
  String iss = null;
  /* Integer timestamp, measured in the number of seconds since January 1 1970 UTC, indicating when this token is not to be used before, as defined in JWT */
  int nbf = null;
  
  String tokenType = null;
  /* Human-readable identifier for the resource owner who authorized this token. */
  String username = null;
  /* Subject of the token, as defined in JWT. Usually a machine-readable identifier of the resource owner who authorized this token. */
  String sub = null;
  
  Map<String, Object> ext = {};
  /* String identifier for the token, as defined in JWT */
  String jti = null;
  IntrospectionResponse();

  @override
  String toString() {
    return 'IntrospectionResponse[active=$active, aud=$aud, clientId=$clientId, exp=$exp, iat=$iat, iss=$iss, nbf=$nbf, tokenType=$tokenType, username=$username, sub=$sub, ext=$ext, jti=$jti, ]';
  }

  IntrospectionResponse.fromJson(Map<String, dynamic> json) {
    if (json == null) return;
    active = json['active'];
    aud = (json['aud'] == null) ?
      null :
      (json['aud'] as List).cast<String>();
    clientId = json['client_id'];
    exp = json['exp'];
    iat = json['iat'];
    iss = json['iss'];
    nbf = json['nbf'];
    tokenType = json['token_type'];
    username = json['username'];
    sub = json['sub'];
    ext = (json['ext'] == null) ?
      null :
      Object.mapFromJson(json['ext']);
    jti = json['jti'];
  }

  Map<String, dynamic> toJson() {
    Map <String, dynamic> json = {};
    if (active != null)
      json['active'] = active;
    if (aud != null)
      json['aud'] = aud;
    if (clientId != null)
      json['client_id'] = clientId;
    if (exp != null)
      json['exp'] = exp;
    if (iat != null)
      json['iat'] = iat;
    if (iss != null)
      json['iss'] = iss;
    if (nbf != null)
      json['nbf'] = nbf;
    if (tokenType != null)
      json['token_type'] = tokenType;
    if (username != null)
      json['username'] = username;
    if (sub != null)
      json['sub'] = sub;
    if (ext != null)
      json['ext'] = ext;
    if (jti != null)
      json['jti'] = jti;
    return json;
  }

  static List<IntrospectionResponse> listFromJson(List<dynamic> json) {
    return json == null ? List<IntrospectionResponse>() : json.map((value) => IntrospectionResponse.fromJson(value)).toList();
  }

  static Map<String, IntrospectionResponse> mapFromJson(Map<String, dynamic> json) {
    var map = Map<String, IntrospectionResponse>();
    if (json != null && json.isNotEmpty) {
      json.forEach((String key, dynamic value) => map[key] = IntrospectionResponse.fromJson(value));
    }
    return map;
  }

  // maps a json object with a list of IntrospectionResponse-objects as value to a dart map
  static Map<String, List<IntrospectionResponse>> mapListFromJson(Map<String, dynamic> json) {
    var map = Map<String, List<IntrospectionResponse>>();
     if (json != null && json.isNotEmpty) {
       json.forEach((String key, dynamic value) {
         map[key] = IntrospectionResponse.listFromJson(value);
       });
     }
     return map;
  }
}

