part of forestvpn_auth_api.api;

class TokenResponse {
  
  String refreshToken = null;
  
  String accessToken = null;
  
  DateTime expiresAt = null;
  
  int expiresIn = null;
  
  String tokenType = null;
  TokenResponse();

  @override
  String toString() {
    return 'TokenResponse[refreshToken=$refreshToken, accessToken=$accessToken, expiresAt=$expiresAt, expiresIn=$expiresIn, tokenType=$tokenType, ]';
  }

  TokenResponse.fromJson(Map<String, dynamic> json) {
    if (json == null) return;
    refreshToken = json['refresh_token'];
    accessToken = json['access_token'];
    expiresAt = (json['expires_at'] == null) ?
      null :
      DateTime.parse(json['expires_at']);
    expiresIn = json['expires_in'];
    tokenType = json['token_type'];
  }

  Map<String, dynamic> toJson() {
    Map <String, dynamic> json = {};
    if (refreshToken != null)
      json['refresh_token'] = refreshToken;
    if (accessToken != null)
      json['access_token'] = accessToken;
    if (expiresAt != null)
      json['expires_at'] = expiresAt == null ? null : expiresAt.toUtc().toIso8601String();
    if (expiresIn != null)
      json['expires_in'] = expiresIn;
    if (tokenType != null)
      json['token_type'] = tokenType;
    return json;
  }

  static List<TokenResponse> listFromJson(List<dynamic> json) {
    return json == null ? List<TokenResponse>() : json.map((value) => TokenResponse.fromJson(value)).toList();
  }

  static Map<String, TokenResponse> mapFromJson(Map<String, dynamic> json) {
    var map = Map<String, TokenResponse>();
    if (json != null && json.isNotEmpty) {
      json.forEach((String key, dynamic value) => map[key] = TokenResponse.fromJson(value));
    }
    return map;
  }

  // maps a json object with a list of TokenResponse-objects as value to a dart map
  static Map<String, List<TokenResponse>> mapListFromJson(Map<String, dynamic> json) {
    var map = Map<String, List<TokenResponse>>();
     if (json != null && json.isNotEmpty) {
       json.forEach((String key, dynamic value) {
         map[key] = TokenResponse.listFromJson(value);
       });
     }
     return map;
  }
}

